=== debian/rules ===
--- 
+++ 
@@ -21,8 +21,11 @@
 	  libdir=/usr/lib/$(DEB_HOST_MULTIARCH)
 
 override_dh_auto_install:
-	rm $(CURDIR)/test/sam
+	rm $(CURDIR)/test/sam $(CURDIR)/test/test-regidx
 	dh_auto_install -- \
 	  prefix=/usr \
 	  libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
 	  PACKAGE_VERSION="$(DEB_VERSION)"
+
+override_dh_installchangelogs:
+	dh_installchangelogs NEWS
