## htslib 1.3

=== debian/changelog ===
htslib (1.3-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Charles Plessy <plessy@debian.org>  Mon, 08 Feb 2016 12:42:45 +0900

htslib (1.3-1) unstable; urgency=medium

  * Team upload
  * New upstream version
  * Ignore metadata files different between git and tarball

 -- Sascha Steinbiss <sascha@steinbiss.name>  Sat, 30 Jan 2016 12:16:06 +0000

htslib (1.2.1-2) unstable; urgency=medium

  * Team upload
  * Enable build on hurd-i386
    Closes: #793512
  * More verbose description vor -dev and -test package
  * Fix lintian override
  * Verified Mayhem bug report which is solved in this version
    Closes: #716376

 -- Andreas Tille <tille@debian.org>  Wed, 09 Dec 2015 17:00:47 +0100

htslib (1.2.1-1~bpo8+1) jessie-backports; urgency=medium

  * Team upload.
  * Rebuild for jessie-backports.

 -- Afif Elghraoui <afif@ghraoui.name>  Mon, 28 Sep 2015 18:43:33 -0700
