=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                zlib1g-dev
 Standards-Version: 3.9.6
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/htslib.git
-Vcs-Git: git://anonscm.debian.org/debian-med/htslib.git -b debian/unstable
+Vcs-Git: https://anonscm.debian.org/git/debian-med/htslib.git -b debian/unstable
 Homepage: https://github.com/samtools/htslib
 
 Package: libhts1
@@ -36,6 +36,16 @@
 Depends: libhts1 (= ${binary:Version}),
          ${misc:Depends}
 Description: Development files for the HTSlib
+ HTSlib is an implementation of a unified C library for accessing common file
+ formats, such as SAM (Sequence Alignment/Map), CRAM and VCF (Variant Call
+ Format), used for high-throughput sequencing data, and is the core library
+ used by samtools and bcftools. HTSlib only depends on zlib. It is known to be
+ compatible with gcc, g++ and clang.
+ .
+ HTSlib implements a generalized BAM (binary SAM) index, with file extension
+ ‘csi’ (coordinate-sorted index). The HTSlib file reader first looks for the
+ new index and then for the old if the new index is absent.
+ .
  This package contains development files for the HTSlib: headers, static
  library, manual pages, etc.
 
@@ -44,6 +54,16 @@
 Depends: ${misc:Depends},
          ${perl:Depends}
 Description: Test data for HTSlib
+ HTSlib is an implementation of a unified C library for accessing common file
+ formats, such as SAM (Sequence Alignment/Map), CRAM and VCF (Variant Call
+ Format), used for high-throughput sequencing data, and is the core library
+ used by samtools and bcftools. HTSlib only depends on zlib. It is known to be
+ compatible with gcc, g++ and clang.
+ .
+ HTSlib implements a generalized BAM (binary SAM) index, with file extension
+ ‘csi’ (coordinate-sorted index). The HTSlib file reader first looks for the
+ new index and then for the old if the new index is absent.
+ .
  This package contains test files and scripts for the HTSlib.
 
 Package: tabix
