## htslib 1.3.1

=== debian/changelog ===
htslib (1.3.1-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Charles Plessy <plessy@debian.org>  Sun, 08 May 2016 21:28:33 +0900

htslib (1.3.1-1) unstable; urgency=medium

  36bf59a Merge tag '1.3.1' into debian/unstable
  559f8b4 Remove add_largefile.patch, applied upstream.
  7163afb Update symbols file. Missing _vcf_parse_format@Base and fai_read@Base.
  c2c1df3 Build-depend on libcurl4-gnutls-dev and libssl-dev.
  3b219b8 Enable libcurl.
  9101580 Conforms to the Policy version 3.9.8.

 -- Charles Plessy <plessy@debian.org>  Mon, 25 Apr 2016 22:28:11 +0900

htslib (1.3-2) unstable; urgency=medium

  * Team upload

  [ Steffen Moeller and Jon Ison ]
  * Introduction of EDAM annotation

  [ Sascha Steinbiss ]
  * Include upstream patch for large file support
  * Run configure as part of the build

 -- Sascha Steinbiss <sascha@steinbiss.name>  Mon, 08 Feb 2016 16:46:35 +0000
