=== debian/control ===
--- 
+++ 
@@ -5,8 +5,11 @@
 Priority: optional
 Build-Depends: debhelper (>= 9),
                dh-exec,
-               zlib1g-dev
-Standards-Version: 3.9.6
+               libcurl4-gnutls-dev,
+               libssl-dev,
+               zlib1g-dev,
+               autoconf
+Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/htslib.git
 Vcs-Git: https://anonscm.debian.org/git/debian-med/htslib.git -b debian/unstable
 Homepage: https://github.com/samtools/htslib
