=== debian/rules ===
--- 
+++ 
@@ -10,6 +10,10 @@
 	dh_auto_test
 	$(RM) test/*.tmp test/*.tmp.* test/*.o test/*.dSYM \
               test/fieldarith test/hfile test/test_view test/test-vcf-api test/test-vcf-sweep
+
+override_dh_auto_configure:
+	autoconf
+	./configure --enable-libcurl
 
 override_dh_auto_build:
 	dh_auto_build -- \
